# COKE Docs

## Basic Info

- Server Requirements
- Change Log
- Credits



## Installation

- Windows
- Mac
- Ubuntu



## Introduction

- node.js basics
  - CommonJS `require` & `exports`
- Quick start
- Features
- Application Flow Chart
- MVC architecture
- Architectural Goals
- Project structure
- Third party library compatibility ( Socket.io, Express, Connect ... )



## Command line tools

- Command list
- Generators
- Routes
- Start server
- Writing your own generators



## Configuration

- Server
- Database
- Express
  - basepath
  - views
  - view engine
  - view options
  - view cache
  - case sensitive routes
  - strict routing
  - jsonp callback
- Routes
- Assets



## Logger

## Routes

- URLs
- RESTful routes
- Nested resources
- Namespacing


## Middleware

- What is `next`?
- app.redirect
- app.error
- app.helpers
- Write your own



## Controller

- Request
  - cookie
  - clearCookie
  - session
  - flash
  - header
  - param
  - accepts
  - is
  - get
  - isXMLHttpRequest
- Response
  - header
  - charset
  - contentType
  - attachment
  - sendfile
  - download
  - redirect
  - send
  - json
  - render
  - partial
  - local
  - locals




## View

- Template Syntax
- Render options
- Layout
- Action view
- Partial



## Helper

- Helper & dynamic helper


## Model

- Mongodb
- Mongoose
  - CRUD
- Validation
- Hooks



## Library

- npm package vs app level lib



## Assets

- Naming
- Packing



## i18n



## Error Handling



## Caching



## Profiling



## Coding style guide



## Test

- should
- zombie



## Tools

- Zencoding
- Comapss & SASS(Why not LESS or Stylus?)


## Deploy & Production

- Http vs https
- Nginx reverse proxy vs cluster module
- Ubuntu
- Linode
- AWS


